<html><head><link rel='stylesheet' href='ejsS.doc.css'></head><body>
<h2>Classes</h2><ul>
<li><a href='#EJSS_DRAWING2D.Arrow'>EJSS_DRAWING2D.Arrow</a></li>
<li><a href='#EJSS_DRAWING2D.ArrowSet'>EJSS_DRAWING2D.ArrowSet</a></li>
<li><a href='#EJSS_DRAWING2D.Axis'>EJSS_DRAWING2D.Axis</a></li>
<li><a href='#EJSS_DRAWING2D.Custom'>EJSS_DRAWING2D.Custom</a></li>
<li><a href='#EJSS_DRAWING2D.DrawingPanel'>EJSS_DRAWING2D.DrawingPanel</a></li>
<li><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></li>
<li><a href='#EJSS_DRAWING2D.Histogram'>EJSS_DRAWING2D.Histogram</a></li>
<li><a href='#EJSS_DRAWING2D.PlottingPanel'>EJSS_DRAWING2D.PlottingPanel</a></li>
<li><a href='#EJSS_DRAWING2D.Segment'>EJSS_DRAWING2D.Segment</a></li>
<li><a href='#EJSS_DRAWING2D.Shape'>EJSS_DRAWING2D.Shape</a></li>
<li><a href='#EJSS_DRAWING2D.SimplePanel'>EJSS_DRAWING2D.SimplePanel</a></li>
<li><a href='#EJSS_DRAWING2D.Text'>EJSS_DRAWING2D.Text</a></li>
<li><a href='#EJSS_DRAWING2D.Trace'>EJSS_DRAWING2D.Trace</a></li>
<li><a href='#EJSS_DRAWING2D.Trail'>EJSS_DRAWING2D.Trail</a></li>
<li><a href='#EJSS_DRAWING3D.Arrow'>EJSS_DRAWING3D.Arrow</a></li>
<li><a href='#EJSS_DRAWING3D.ArrowSet'>EJSS_DRAWING3D.ArrowSet</a></li>
<li><a href='#EJSS_DRAWING3D.Cylinder'>EJSS_DRAWING3D.Cylinder</a></li>
<li><a href='#EJSS_DRAWING3D.Disk'>EJSS_DRAWING3D.Disk</a></li>
<li><a href='#EJSS_DRAWING3D.DrawingPanel'>EJSS_DRAWING3D.DrawingPanel</a></li>
<li><a href='#EJSS_DRAWING3D.Element'>EJSS_DRAWING3D.Element</a></li>
<li><a href='#EJSS_DRAWING3D.ElementSet'>EJSS_DRAWING3D.ElementSet</a></li>
<li><a href='#EJSS_DRAWING3D.Sphere'>EJSS_DRAWING3D.Sphere</a></li>
<li><a href='#TextArea'>TextArea</a></li>
</ul>
<h3><a name='EJSS_DRAWING2D.Arrow'>EJSS_DRAWING2D.Arrow</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Arrow</td><td>Arrow is a class to display vectors</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></td></tr>
</tbody></table>
<br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>MarkEndOrient</td><td>Orientation of the marker. Values are "auto" or the angle to rotate the marker</td><td>int|String</td><td>"auto"</td><td>-</td></tr>
<tr><td>MarkMiddleOrient</td><td>Orientation of the marker. Values are "auto" or the angle to rotate the marker</td><td>int|String</td><td>"auto"</td><td>-</td></tr>
<tr><td>MarkStartOrient</td><td>Orientation of the marker. Values are "auto" or the angle to rotate the marker</td><td>int|String</td><td>"auto"</td><td>-</td></tr>
</tbody></table>
<br><br>
<h3><a name='EJSS_DRAWING2D.ArrowSet'>EJSS_DRAWING2D.ArrowSet</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.ArrowSet</td><td>ArrowSet is a set of Arrows</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>MarkEndOrient</td><td>Orientation of the marker. Values are "auto" or the angle to rotate the marker</td><td>int|String</td><td>"auto"</td><td>-</td></tr>
<tr><td>MarkMiddleOrient</td><td>Orientation of the marker. Values are "auto" or the angle to rotate the marker</td><td>int|String</td><td>"auto"</td><td>-</td></tr>
<tr><td>MarkStartOrient</td><td>Orientation of the marker. Values are "auto" or the angle to rotate the marker</td><td>int|String</td><td>"auto"</td><td>-</td></tr>
</tbody></table>
<br><br>
<h3><a name='EJSS_DRAWING2D.Axis'>EJSS_DRAWING2D.Axis</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Axis</td><td>An Axis is the 2D drawable used by PlottingPanels as decoration</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Segment'>EJSS_DRAWING2D.Segment</a></td></tr>
</tbody></table>
<br><br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>getAutoTicks</td><td>-</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>setAutoTicks</td><td>-</td><td>auto; </td><td>-</td><td>-</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.Custom'>EJSS_DRAWING2D.Custom</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Custom</td><td>A Custom element is a 2D drawing element that executes a user function for drawing</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></td></tr>
</tbody></table>
<br><br><br>
<h3><a name='EJSS_DRAWING2D.DrawingPanel'>EJSS_DRAWING2D.DrawingPanel</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.DrawingPanel</td><td>A DrawingPanel is a 2D drawing panel with no decoration.</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>AutoScaleX</td><td>Whether the panel should autoscale in the X dimension</td><td>boolean</td><td>"false"</td><td>-</td></tr>
<tr><td>AutoScaleY</td><td>Whether the panel should autoscale in the Y dimension</td><td>boolean</td><td>"false"</td><td>-</td></tr>
<tr><td>Background</td><td>The fill color for the main drawing area of the panel
 See <a href="http://www.w3schools.com/cssref/css_colornames.asp">this link</a> for possible values.</td><td>string Any valid CSS color name. "none" for no color</td><td>"rgb(239,239,255) for DrawingPanels, White for PlottingPanels"</td><td>-</td></tr>
<tr><td>CSS</td><td>An object with one or more CSS properties.
 Example { "background-color" : "red", "float" : "right" }</td><td>Object</td><td>"inline"</td><td>-</td></tr>
<tr><td>ClassName</td><td>A classname for the element that can be used in CSS files</td><td>String</td><td>"undefined"</td><td>-</td></tr>
<tr><td>CursorTypeForMove</td><td>The type of cursor when an element is moved.
 See <a href="http://www.w3schools.com/cssref/pr_class_cursor.asp">this link</a> for possible values.</td><td>String</td><td>"move"</td><td>-</td></tr>
<tr><td>Display</td><td>The CSS display property of the element
 See <a href="http://www.w3schools.com/cssref/pr_class_display.asp">this link</a> for possible values.</td><td>string</td><td>"inline"</td><td>-</td></tr>
<tr><td>DrawFill</td><td>Whether to fill the main drawing area of the panel.</td><td>boolean</td><td>"true"</td><td>-</td></tr>
<tr><td>DrawLines</td><td>Whether to draw the inner border of the panel (inside border of the gutter).</td><td>boolean</td><td>"true"</td><td>-</td></tr>
<tr><td>Enabled</td><td>Whether the panel should respond to user interaction.
 This is set to "false" by default, since 'listening' to interaction slows down the rendering.</td><td>boolean</td><td>"false"</td><td>-</td></tr>
<tr><td>FillColor</td><td>The fill color for the main drawing area of the panel.
 Same as "Background"
 See <a href="http://www.w3schools.com/cssref/css_colornames.asp">this link</a> for possible values.</td><td>string Any valid CSS color name. "none" for no color</td><td>"rgb(239,239,255) for DrawingPanels, White for PlottingPanels"</td><td>-</td></tr>
<tr><td>Foreground</td><td>The stroke color for the border of the main drawing area of the panel (inner border of the gutters)
 See <a href="http://www.w3schools.com/cssref/css_colornames.asp">this link</a> for possible values.</td><td>string Any valid CSS color name. "none" for no color</td><td>"Black"</td><td>-</td></tr>
<tr><td>GraphicsMode</td><td>The type of graphics implementation of the panel. 
 Changing the graphics mode may influence what elements are actually displayed and the interaction response of the panel.
 But it may also influence the rendering speed.</td><td>int or String. One of: <ul>   <li>EJSS_DRAWING2D.DrawingPanel.GRAPHICS2D_SVG ("SVG" for short): SVG based drawing, full interaction, may be slower</li> 
   <li>EJSS_DRAWING2D.DrawingPanel.GRAPHICS2D_CANVAS ("CANVAS" for short): Canvas-based drawing, reduced interaction, usually faster</li>
 </ul></td><td>"SCALE_NUM"</td><td>-</td></tr>
<tr><td>Gutters</td><td>The dimensions of a strip around the main panel drawing area</td><td>int[4] representing [left,top,right,bottom], the size of the strip (in pixels) in that part of the panel</td><td>"[0,0,0,0] for DrawingPanels, [50,50,50,50] for PlottingPanels"</td><td>-</td></tr>
<tr><td>GuttersColor</td><td>The fill color for the gutter.
 See <a href="http://www.w3schools.com/cssref/css_colornames.asp">this link</a> for possible values.</td><td>string Any valid CSS color name. "none" for no color</td><td>"rgb(239,239,255) for DrawingPanels, rgb(211,216,255) for PlottingPanels"</td><td>-</td></tr>
<tr><td>GuttersDrawLines</td><td>Whether to draw the outer border of the panel (exterior border of the gutter).</td><td>boolean</td><td>"true"</td><td>-</td></tr>
<tr><td>GuttersFill</td><td>Whether to fill the gutter.</td><td>boolean</td><td>"true"</td><td>-</td></tr>
<tr><td>GuttersLineColor</td><td>The stroke color for the outer border of the panel (exterior border of the gutter).
 See <a href="http://www.w3schools.com/cssref/css_colornames.asp">this link</a> for possible values.</td><td>string Any valid CSS color name. "none" for no color</td><td>"Black"</td><td>-</td></tr>
<tr><td>GuttersLineWidth</td><td>The stroke width for the outer border of the panel (exterior border of the gutter).</td><td>int width in pixels</td><td>"1"</td><td>-</td></tr>
<tr><td>GuttersRendering</td><td>SVG shape rendering for the gutters</td><td>string</td><td>"auto"</td><td>"auto","optimizeSpeed","crispEdges","geometricPrecision"</td></tr>
<tr><td>Height</td><td>The height of the HTML5 element.
 See <a href="http://www.w3schools.com/cssref/pr_dim_width.asp">this link</a> for possible values.</td><td>int or String</td><td>"auto"</td><td>-</td></tr>
<tr><td>LineColor</td><td>The stroke color for the border of the main drawing area of the panel (inner border of the gutters).
 Same as "Foreground".
 See <a href="http://www.w3schools.com/cssref/css_colornames.asp">this link</a> for possible values.</td><td>string Any valid CSS color name. "none" for no color</td><td>"Black"</td><td>-</td></tr>
<tr><td>LineWidth</td><td>The stroke width for the border of the main drawing area of the panel (inner border of the gutters).</td><td>int width in pixels</td><td>"1"</td><td>-</td></tr>
<tr><td>MarginX</td><td>When autoscaling the X axis, the percentage of the X range that should be left (on both sides) around the elements</td><td>int or double (in the range [0,100])</td><td>"0"</td><td>-</td></tr>
<tr><td>MarginY</td><td>When autoscaling the Y axis, the percentage of the Y range that should be left (on both sides) around the elements</td><td>int or double (in the range [0,100])</td><td>"0"</td><td>-</td></tr>
<tr><td>MaximumX</td><td>The maximum value for the X coordinates of elements. 
 If specified, the maximum is respected even if AutoscaleX is true and there are no elements close to the maximum.</td><td>int or double</td><td>"+1"</td><td>-</td></tr>
<tr><td>MaximumXY</td><td>The maximum value for the Y coordinates of elements. 
 If specified, the maximum is respected even if AutoscaleY is true and there are no elements close to the maximum.</td><td>int or double</td><td>"+1"</td><td>-</td></tr>
<tr><td>MinimumX</td><td>The minimum value for the X coordinates of elements. 
 If specified, the minimum is respected even if AutoscaleX is true and there are no elements close to the minimum.</td><td>int or double</td><td>"-1"</td><td>-</td></tr>
<tr><td>MinimumY</td><td>The minimum value for the Y coordinates of elements. 
 If specified, the minimum is respected even if AutoscaleY is true and there are no elements close to the minimum.</td><td>int or double</td><td>"-1"</td><td>-</td></tr>
<tr><td>ScaleXType</td><td>The type of scale for the X axis</td><td>int or String. One of: <ul>   <li>EJSS_DRAWING2D.DrawingPanel.SCALE_NUM ("SCALE_NUM" for short)</li>
   <li>EJSS_DRAWING2D.DrawingPanel.SCALE_LOG ("SCALE_LOG" for short)</li>
 </ul></td><td>"SCALE_NUM"</td><td>-</td></tr>
<tr><td>ScaleYType</td><td>The type of scale for the Y axis</td><td>int or String. One of: <ul>   <li>EJSS_DRAWING2D.DrawingPanel.SCALE_NUM ("SCALE_NUM" for short)</li>
   <li>EJSS_DRAWING2D.DrawingPanel.SCALE_LOG ("SCALE_LOG" for short)</li>
 </ul></td><td>"SCALE_NUM"</td><td>-</td></tr>
<tr><td>SquareAspect</td><td>Whether the panel should modify its scales to keep a 1:1 aspect ratio.</td><td>boolean</td><td>"false"</td><td>-</td></tr>
<tr><td>StopEventPropagation</td><td>Whether to propagate events and gestures to the containing HTML element.
 This may be useful, for instance, to prevent ePub readers from reacting to what should be just an interaction with the panel.</td><td>boolean</td><td>"true"</td><td>-</td></tr>
<tr><td>StopMoveEvents</td><td>Whether to enable the move event listener.
 This is set to "false" by default and is ignored when Enabled is set to "false".</td><td>boolean</td><td>"false"</td><td>-</td></tr>
<tr><td>Visibility</td><td>Whether the element is visible</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>Width</td><td>The width of the HTML5 element.
 See <a href="http://www.w3schools.com/cssref/pr_dim_width.asp">this link</a> for possible values.</td><td>int or String</td><td>"auto"</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>addDecoration</td><td>Adds a decoration to the panel. Decorations are drawn before any other elements.</td><td>drawable decoration element; position integer; istop top decoration; </td><td>-</td><td>-</td></tr>
<tr><td>addElement</td><td>Add a element to the panel. Elements are asked to draw themselves
 whenever the panel needs to render. For this purpose, they will receive a
 calls to draw().
 Elements are reported of changes in the world coordinates of the panel, in case
 they need to recalculate themselves.</td><td>element Element; position int; </td><td>-</td><td>-</td></tr>
<tr><td>checkMeasure</td><td>Recalculate world dimensions using measure elements</td><td>-</td><td>boolean whether dimesions update</td><td>-</td></tr>
<tr><td>disable</td><td>Disable rendering</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>enable</td><td>Enable rendering</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>getAutoScale</td><td>Get auto-scale</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getAutoScaleX</td><td>Get auto-scale in X</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getAutoScaleY</td><td>Get auto-scale in Y</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getController</td><td>Returns the controller object</td><td>-</td><td>Controller</td><td>-</td></tr>
<tr><td>getElements</td><td>Return the array of a elements.</td><td>-</td><td>Elements</td><td>-</td></tr>
<tr><td>getEnabledDragging</td><td>Type of motion allowed to drag panel</td><td>-</td><td>motion</td><td>-</td></tr>
<tr><td>getEnabledZooming</td><td>Whether panal scaling is allowed</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getGraphics</td><td>Returns the graphics implementation</td><td>-</td><td>Graphics</td><td>-</td></tr>
<tr><td>getGraphicsMode</td><td>Get the graphics mode</td><td>-</td><td>One of the possible graphics implementation mode: EJSS_DRAWING2D.DrawingPanel.GRAPHICS2D_SVG or EJSS_DRAWING2D.DrawingPanel.GRAPHICS2D_CANVAS</td><td>-</td></tr>
<tr><td>getGraphicsModeName</td><td>Get the graphics mode</td><td>-</td><td>The implementation mode as a string: either "SVG" or "CANVAS"</td><td>-</td></tr>
<tr><td>getGutters</td><td>Return the bounding gutters</td><td>-</td><td>Gutters</td><td>-</td></tr>
<tr><td>getGuttersStyle</td><td>Return the drawing style of the bounding gutters</td><td>-</td><td>Style</td><td>-</td></tr>
<tr><td>getInnerRect</td><td>Return drawing box (excluding gutters)</td><td>-</td><td>box</td><td>-</td></tr>
<tr><td>getInvertedScaleY</td><td>Get inverted scale in Y</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getMarginX</td><td>Get margin X</td><td>-</td><td>margin</td><td>-</td></tr>
<tr><td>getMarginY</td><td>Get margin Y</td><td>-</td><td>margin</td><td>-</td></tr>
<tr><td>getMeasuredCoordinates</td><td>Gets the measured coordinates for the panel</td><td>-</td><td>bounds</td><td>-</td></tr>
<tr><td>getName</td><td>Get name for drawing panel</td><td>-</td><td>string</td><td>-</td></tr>
<tr><td>getPanelInteraction</td><td>Return Panel Interaction</td><td>panel interaction; </td><td>-</td><td>-</td></tr>
<tr><td>getPixelPositionWorldOrigin</td><td>Get pixel position of the origin</td><td>-</td><td>array pixel position</td><td>-</td></tr>
<tr><td>getRealWorldCoordinates</td><td>Gets the user coordinates for the panel</td><td>-</td><td>bounds</td><td>-</td></tr>
<tr><td>getRealWorldXMax</td><td>Returns the maximum X coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getRealWorldXMin</td><td>Returns the minimum X coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getRealWorldYMax</td><td>Returns the maximum Y coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getRealWorldYMin</td><td>Returns the minimum Y coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getShowAreaRectangle</td><td>Show area rectangle in panel</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>getShowCoordinates</td><td>Whether coordinates in panel are showed</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getStyle</td><td>Return the drawing style of the inner rectangle for panel</td><td>-</td><td>Style</td><td>-</td></tr>
<tr><td>getTypeScaleX</td><td>Get type of scale in X</td><td>-</td><td>int</td><td>-</td></tr>
<tr><td>getTypeScaleY</td><td>Get type of scale in Y</td><td>-</td><td>int</td><td>-</td></tr>
<tr><td>getWorldCoordinates</td><td>Gets the preferred user coordinates for the panel</td><td>-</td><td>bounds</td><td>-</td></tr>
<tr><td>getWorldXMax</td><td>Returns the preferred maximum X coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldXMin</td><td>Returns the preferred minimum X coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldYMax</td><td>Returns the preferred maximum Y coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldYMin</td><td>Returns the preferred minimum Y coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getZoomLimits</td><td>Get zoom limits</td><td>-</td><td>limits [min,max]</td><td>-</td></tr>
<tr><td>getZoomRate</td><td>Get zoom rate</td><td>-</td><td>rate</td><td>-</td></tr>
<tr><td>importGraphics</td><td>Returns the svg image in Base64 format</td><td>callback; </td><td>string</td><td>-</td></tr>
<tr><td>indexOfElement</td><td>Return the position of a element.</td><td>element Element; </td><td>integer</td><td>-</td></tr>
<tr><td>recomputeScales</td><td>Recomputes the scales of the panel.</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>removeDecoration</td><td>Removes a decoration</td><td>drawable decoration element; </td><td>-</td><td>-</td></tr>
<tr><td>removeElement</td><td>Remove a element to the panel.</td><td>element Element; </td><td>-</td><td>-</td></tr>
<tr><td>render</td><td>Render the scene</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>reportDecorations</td><td>Report event to decoration elements</td><td>event; </td><td>-</td><td>-</td></tr>
<tr><td>reset</td><td>Reset the scene</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>scale</td><td>Force scale again</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>serialize</td><td>Get JSON object with private variables</td><td>-</td><td>-</td><td>private</td></tr>
<tr><td>setAutoScale</td><td>Set auto-scale</td><td>auto; </td><td>-</td><td>-</td></tr>
<tr><td>setAutoScaleX</td><td>Set auto-scale in X</td><td>auto; </td><td>-</td><td>-</td></tr>
<tr><td>setAutoScaleY</td><td>Set auto-scale in Y</td><td>auto; </td><td>-</td><td>-</td></tr>
<tr><td>setController</td><td>Set the controller</td><td>Controller; </td><td>-</td><td>-</td></tr>
<tr><td>setEnabledDragging</td><td>Allow to drag panel</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>setEnabledZooming</td><td>Allow to scale panel</td><td>allowed; </td><td>-</td><td>-</td></tr>
<tr><td>setGraphicsMode</td><td>Set graphics</td><td>mode One of the possible graphics implementation mode:    EJSS_DRAWING2D.DrawingPanel.GRAPHICS2D_SVG or EJSS_DRAWING2D.DrawingPanel.GRAPHICS2D_CANVAS. Or simply "CANVAS" or "SVG"; </td><td>-</td><td>-</td></tr>
<tr><td>setGutters</td><td>Sets the gutters dimensions</td><td>rect the number of pixels for the drawing area; </td><td>-</td><td>-</td></tr>
<tr><td>setInvertedScaleY</td><td>Set inverted scale in Y</td><td>inverted; </td><td>-</td><td>-</td></tr>
<tr><td>setMarginX</td><td>Set margin X</td><td>margin; </td><td>-</td><td>-</td></tr>
<tr><td>setMarginY</td><td>Set margin Y</td><td>margin; </td><td>-</td><td>-</td></tr>
<tr><td>setShowAreaRectangle</td><td>Show area rectangle in panel</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setShowCoordinates</td><td>Show coordinates in panel</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setSquareAspect</td><td>Whether the panel should keep a 1:1 aspect ratio between X and Y coordinates</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setTypeScaleX</td><td>Set type of scale in X</td><td>type; </td><td>-</td><td>-</td></tr>
<tr><td>setTypeScaleY</td><td>Set type of scale in Y</td><td>type; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldCoordinates</td><td>Sets the preferred user coordinates for the panel</td><td>bounds; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldXMax</td><td>Sets the preferred maximum X coordinate for the panel</td><td>xmax; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldXMin</td><td>Sets the preferred minimum X coordinate for the panel</td><td>xmin; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldYMax</td><td>Sets the preferred maximum Y coordinate for the panel</td><td>ymax; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldYMin</td><td>Sets the preferred minimum Y coordinate for the panel</td><td>ymin; </td><td>-</td><td>-</td></tr>
<tr><td>setZoomLimits</td><td>Set zoom limits</td><td>limits [min,max]; </td><td>-</td><td>-</td></tr>
<tr><td>setZoomRate</td><td>Set zoom rate</td><td>rate; </td><td>-</td><td>-</td></tr>
<tr><td>toPanelLogScale</td><td>Projects a value in pixel coordinates from a decimal scale 
 (defined by origin, min, max and pixratio) to a log scale in world coordinates</td><td>value double The original value; origin double The origin in panel (pixels); min double The min value in world coordinates; max double The max value in world coordinates; pixratio double The pixels per unit for panel; </td><td>double The value transformed</td><td>-</td></tr>
<tr><td>toPanelMod</td><td>To be used only after a call to render()!
 Projects a module from pixel coordinates to world coordinates</td><td>point double[] The original module; </td><td>double[] The same array once transformed</td><td>-</td></tr>
<tr><td>toPanelPosition</td><td>To be used only after a call to render()!
 Projects a point from pixel coordinates to world coordinates</td><td>point double[] The original coordinates; scale double[] The type of scale (LOG or NUM); </td><td>double[] The same array once transformed</td><td>-</td></tr>
<tr><td>toPixelAxisX</td><td>Converts a X pixel value so that 0 is at the left</td><td>x double; </td><td>-</td><td>-</td></tr>
<tr><td>toPixelAxisY</td><td>Converts a Y pixel value so that 0 is at the bottom</td><td>y double; </td><td>-</td><td>-</td></tr>
<tr><td>toPixelLogScale</td><td>Projects a value in world coordinates from a decimal scale 
 (defined by origin, min, max and pixratio) to a log scale in pixel coordinates</td><td>value double The original value; origin double The origin in panel (pixels); min double The min value in world coordinates; max double The max value in world coordinates; pixratio double The pixels per unit for panel; </td><td>double The value transformed</td><td>-</td></tr>
<tr><td>toPixelMod</td><td>To be used only after a call to render()!
 Projects a module from world coordinates to pixel coordinates</td><td>point double[] The original module; </td><td>double[] The same array once transformed</td><td>-</td></tr>
<tr><td>toPixelPosition</td><td>To be used only after a call to render()!
 Projects a point from world coordinates to pixel coordinates.</td><td>point double[] The original coordinates; scale double[] The type of scale (LOG or NUM); </td><td>double[] An array with the result</td><td>-</td></tr>
<tr><td>touch</td><td>Refresh all elements</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>unserialize</td><td>Set JSON object with private variables</td><td>-</td><td>-</td><td>private</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Element</td><td>Basic Element 2D</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>Attributes</td><td>Inline SVG attributtes</td><td>object</td><td>-</td><td>{nameAttr1:value1,nameAttr2:value2,..}</td></tr>
<tr><td>Bounds</td><td>Position of the bounding box of the element</td><td>Object{left,rigth,top,bottom}</td><td>-</td><td>-</td></tr>
<tr><td>Diameter</td><td>Diameter, i.e. the value of the width and the height</td><td>double</td><td>-</td><td>-</td></tr>
<tr><td>DrawFill</td><td>Whether the fill color is drawed</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>DrawLines</td><td>Whether the stroke is drawed</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>EnabledPosition</td><td>Whether the user could change the position</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>EnabledSize</td><td>Whether the user could change the size</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>FillColor</td><td>Fill color</td><td>string</td><td>"none"</td><td>-</td></tr>
<tr><td>LineColor</td><td>Stroke color</td><td>string</td><td>"Black"</td><td>-</td></tr>
<tr><td>LineWidth</td><td>Stroke width</td><td>double</td><td>0.5</td><td>-</td></tr>
<tr><td>Measured</td><td>Measurability of the element</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>MovesGroup</td><td>Whether the group position also changes when the element position changes</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Parent</td><td>Parent of the element</td><td>Panel|Group</td><td>-</td><td>-</td></tr>
<tr><td>PixelPosition</td><td>Whether the position is in pixels</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>PixelSize</td><td>Whether the size is in pixels</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Position</td><td>Coordinates X and Y</td><td>double[2]</td><td>[0,0]</td><td>-</td></tr>
<tr><td>Radius</td><td>Radius, i.e. the half of the diameter</td><td>double</td><td>-</td><td>-</td></tr>
<tr><td>RelativePosition</td><td>Position of the coordinates X and Y relative to the element</td><td>string|int</td><td>"CENTER"</td><td>"CENTER":0,"NORTH":1,"SOUTH":2,"EAST":3,"WEST":4,"NORTH_EAST":5,"NORTH_WEST":6, "SOUTH_EAST":7,"SOUTH_WEST":8</td></tr>
<tr><td>ResizesGroup</td><td>Whether the group size also changes when the element size changes</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Rotate</td><td>Rotation of the element</td><td>int</td><td>0</td><td>int:angle in radians to rotate the element with origin its position</td></tr>
<tr><td>ScaleX</td><td>Scale transformation of the element in X</td><td>float</td><td>1</td><td>float: scale in X</td></tr>
<tr><td>ScaleY</td><td>Scale transformation of the element in Y</td><td>float</td><td>1</td><td>float: scale in Y</td></tr>
<tr><td>Sensitivity</td><td>Sensitivity in pixels when the user touchs the element</td><td>int</td><td>20</td><td>-</td></tr>
<tr><td>SensitivityType</td><td>SensitivityType</td><td>int</td><td>20</td><td>-</td></tr>
<tr><td>ShapeRendering</td><td>SVG shape rendering</td><td>string</td><td>"auto"</td><td>"auto","optimizeSpeed","crispEdges","geometricPrecision"</td></tr>
<tr><td>Size</td><td>Size along the X and Y axes</td><td>double[2]</td><td>[1,1]</td><td>-</td></tr>
<tr><td>SizeX</td><td>Size along the X axis</td><td>double</td><td>1</td><td>-</td></tr>
<tr><td>SizeY</td><td>Size along the Y axis</td><td>double</td><td>1</td><td>-</td></tr>
<tr><td>SkewX</td><td>Skew transformation of the element in X</td><td>float</td><td>1</td><td>float: skew angle in X</td></tr>
<tr><td>SkewY</td><td>Skew transformation of the element in Y</td><td>float</td><td>1</td><td>float: skew angle in Y</td></tr>
<tr><td>Transformation</td><td>Internal transformation of the element</td><td>int|float[6]|string</td><td>0</td><td>int:angle in radians to rotate the element with origin its position,  float[9]: transformation matrix - [scaleX, skewY, skewX, scaleY, translateX, translateY]</td></tr>
<tr><td>Visibility</td><td>Whether the element is visible</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>X</td><td>Position in X</td><td>double</td><td>0</td><td>-</td></tr>
<tr><td>Y</td><td>Position in Y</td><td>double</td><td>0</td><td>-</td></tr>
</tbody></table>
<br><table><thead><th>Action</th><th>Description</th></thead><tbody>
<tr><td>OnDoubleClick</td><td>Event when double click</td></tr>
<tr><td>OnDrag</td><td>Event when the mouse drags the element</td></tr>
<tr><td>OnEnter</td><td>Event when the mouse enters in the element</td></tr>
<tr><td>OnExit</td><td>Event when the mouse exits the element</td></tr>
<tr><td>OnPress</td><td>Event when the mouse clicks over the element</td></tr>
<tr><td>OnRelease</td><td>Event when the mouse release the element</td></tr>
</tbody></table>
<br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>copyTo</td><td>Copies itself to another element</td><td>element Element; </td><td>-</td><td>private</td></tr>
<tr><td>getAbsoluteBounds</td><td>Returns bounds for an element (after applying groups)</td><td>withTransf whether transformation must be considered, note it will be   false (or undefinded) when transformations are applied by svg (drawing); </td><td>Object{left,rigth,top,bottom}</td><td>public</td></tr>
<tr><td>getAbsolutePosition</td><td>Returns the absolute position in the panel (after applying groups)</td><td>withTransf whether transformation must be considered, note it will be   false (or undefinded) when transformations are applied by svg (drawing); </td><td>double[2]</td><td>private</td></tr>
<tr><td>getAbsoluteSize</td><td>Returns the absolute world sizes in the panel (after applying groups)</td><td>-</td><td>double[2]</td><td>private</td></tr>
<tr><td>getBounds</td><td>Returns bounds for an element</td><td>-</td><td>Object{left,rigth,top,bottom}</td><td>public</td></tr>
<tr><td>getController</td><td>Returns the controller object</td><td>-</td><td>Controller</td><td>private</td></tr>
<tr><td>getCustomObject</td><td>Retrieve an object for internal use</td><td>-</td><td>Object</td><td>protected</td></tr>
<tr><td>getGroup</td><td>Get the group of this element, if any</td><td>-</td><td>Group</td><td>private</td></tr>
<tr><td>getGroupPanel</td><td>Returns the DrawingPanel in which it (or its final ancestor group) is displayed</td><td>-</td><td>DrawingPanel</td><td>private</td></tr>
<tr><td>getInfo</td><td>Gets information for element</td><td>-</td><td>string</td><td>private</td></tr>
<tr><td>getInteractionTarget</td><td>Returns array of the interaction targets defined by the element</td><td>-</td><td>targets</td><td>private</td></tr>
<tr><td>getName</td><td>Gets name for element</td><td>-</td><td>string</td><td>public</td></tr>
<tr><td>getPanel</td><td>Gets the panel for this element</td><td>-</td><td>DrawingPanel</td><td>private</td></tr>
<tr><td>getParent</td><td>Gets the property Parent</td><td>-</td><td>Panel|Group</td><td>public</td></tr>
<tr><td>getPixelPosition</td><td>Returns pixel coordinates</td><td>withTransf whether transformation must be considered, note it will be   false (or undefinded) when transformations are applied by svg (drawing); </td><td>double[2]</td><td>private</td></tr>
<tr><td>getPixelPositionOf</td><td>Returns pixel coordinates for the given point in the element's world coordinates</td><td>withTransf whether transformation must be considered, note it will be   false (or undefinded) when transformations are applied by svg (drawing); </td><td>double[2]</td><td>private</td></tr>
<tr><td>getPixelSizeOf</td><td>Returns pixel sizes for the given sizes in the element's world coordinates</td><td>-</td><td>double[2]</td><td>private</td></tr>
<tr><td>getPixelSizes</td><td>Returns pixel sizes</td><td>withTransf whether transformation must be considered, note it will be   false (or undefinded) when transformations are applied by svg (drawing); </td><td>double[2]</td><td>private</td></tr>
<tr><td>getPosition</td><td>Gets the property Position</td><td>-</td><td>double[2]</td><td>public</td></tr>
<tr><td>getRotate</td><td>Gets the property Rotate</td><td>-</td><td>Rotate angle</td><td>public</td></tr>
<tr><td>getScaleX</td><td>Gets the property ScaleX</td><td>-</td><td>scale rate</td><td>public</td></tr>
<tr><td>getScaleY</td><td>Gets the property ScaleY</td><td>-</td><td>scale rate</td><td>public</td></tr>
<tr><td>getSet</td><td>Gets the set of this element, if any</td><td>-</td><td>ElementSet</td><td>private</td></tr>
<tr><td>getSetIndex</td><td>Gets the index of this element in a set, if any</td><td>-</td><td>int</td><td>private</td></tr>
<tr><td>getSize</td><td>Gets the property Size</td><td>-</td><td>double[]</td><td>public</td></tr>
<tr><td>getSizeX</td><td>Gets the property SizeX</td><td>-</td><td>double</td><td>public</td></tr>
<tr><td>getSizeY</td><td>Gets the property SizeY</td><td>-</td><td>double</td><td>public</td></tr>
<tr><td>getSkewX</td><td>Gets the property SkewX</td><td>-</td><td>skew angle</td><td>public</td></tr>
<tr><td>getSkewY</td><td>Gets the property SkewY</td><td>-</td><td>skew angle</td><td>public</td></tr>
<tr><td>getStyle</td><td>Return the style associated to the element</td><td>-</td><td>Style</td><td>public</td></tr>
<tr><td>getTransformation</td><td>Gets the property Transformation</td><td>-</td><td>Transformation - [scaleX, skewY, skewX, scaleY, translateX, translateY]</td><td>public</td></tr>
<tr><td>getX()</td><td>Gets the property X</td><td>-</td><td>double</td><td>public</td></tr>
<tr><td>getY()</td><td>Gets the property Y</td><td>-</td><td>double</td><td>public</td></tr>
<tr><td>isChanged</td><td>Whether the element has changed</td><td>-</td><td>boolean</td><td>private</td></tr>
<tr><td>isGroup</td><td>Is the element a group</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>isGroupChanged</td><td>Returns whether the element group has changed</td><td>-</td><td>boolean</td><td>private</td></tr>
<tr><td>isGroupVisible</td><td>Returns the real visibility status of the element, 
 which will be false if it belongs to an invisible group</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>isMeasured</td><td>Gets the property Measured</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>isMustProject</td><td>Whether the element needs to project. Typically used by the dawing panel 
 whenever it changes its scales</td><td>-</td><td>boolean</td><td>private</td></tr>
<tr><td>isPixelPosition</td><td>Returns the property PixelPosition</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>isPixelSize</td><td>Gets the property PixelSize</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>isVisible</td><td>Gets the property Visibility</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>registerProperties</td><td>Registers properties in a ControlElement</td><td>controller A ControlElement that becomes the element controller; </td><td>-</td><td>private</td></tr>
<tr><td>serialize</td><td>Get JSON object with private variables</td><td>-</td><td>-</td><td>private</td></tr>
<tr><td>setAbsolutePosition</td><td>Sets the absolute position in the panel (after applying groups)  
 Note: Transformations are not considered and it is not supported when pixel position is used</td><td>-</td><td>double[2]</td><td>private</td></tr>
<tr><td>setAbsoluteX</td><td>Sets the absolute position X in the panel (after applying groups)  
 Note: Transformations are not considered and it is not supported when pixel position is used</td><td>-</td><td>double</td><td>private</td></tr>
<tr><td>setAbsoluteY</td><td>Sets the absolute position Y in the panel (after applying groups)  
 Note: Transformations are not considered and it is not supported when pixel position is used</td><td>-</td><td>double</td><td>private</td></tr>
<tr><td>setBounds</td><td>Sets bounds for an element</td><td>Object{left,rigth,top,bottom}|[left,rigth,top,bottom]; </td><td>-</td><td>public</td></tr>
<tr><td>setChanged</td><td>Tells the element that it has changed
 Typically used by subclasses when they change something.</td><td>changed boolean; </td><td>-</td><td>private</td></tr>
<tr><td>setController</td><td>Sets the controller</td><td>Controller; </td><td>-</td><td>private</td></tr>
<tr><td>setCustomObject</td><td>Store an object for internal use</td><td>-</td><td>-</td><td>protected</td></tr>
<tr><td>setGroup</td><td>Sets the group of this element</td><td>group Group; </td><td>-</td><td>private</td></tr>
<tr><td>setMeasured</td><td>Sets the property Measured</td><td>measured boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setMustProject</td><td>Tells the element whether it should reproject its points because the panel
 has changed its projection parameters. Or, the other way round, sets it to false
 if someone (typically methods in subclasses) took care of this already</td><td>needsIt boolean; </td><td>-</td><td>private</td></tr>
<tr><td>setPanel</td><td>Sets the panel for this element</td><td>panel DrawingPanel; </td><td>-</td><td>private</td></tr>
<tr><td>setParent</td><td>Sets the property Parent</td><td>parent Panel or Group; </td><td>-</td><td>public</td></tr>
<tr><td>setPixelPosition</td><td>Sets the property PixelPosition</td><td>pixel boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setPixelSize</td><td>Sets the property PixelSize</td><td>pixel boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setPosition</td><td>Sets the property Position</td><td>position double[2]; </td><td>-</td><td>public</td></tr>
<tr><td>setRotate</td><td>Sets the property Rotate</td><td>Rotate angle; </td><td>-</td><td>public</td></tr>
<tr><td>setScaleX</td><td>Sets the property ScaleX</td><td>scale rate; </td><td>-</td><td>public</td></tr>
<tr><td>setScaleY</td><td>Sets the property ScaleY</td><td>scale rate; </td><td>-</td><td>public</td></tr>
<tr><td>setSet</td><td>Sets the index of this element in the set</td><td>set ElementSet; index int; </td><td>-</td><td>private</td></tr>
<tr><td>setSize</td><td>Sets the property Size</td><td>position double[2]; </td><td>-</td><td>public</td></tr>
<tr><td>setSizeX</td><td>Sets the property SizeX</td><td>sizeX double; </td><td>-</td><td>public</td></tr>
<tr><td>setSizeY</td><td>Sets the property SizeY</td><td>sizeY double; </td><td>-</td><td>public</td></tr>
<tr><td>setSkewX</td><td>Sets the property SkewX</td><td>skew angle; </td><td>-</td><td>public</td></tr>
<tr><td>setSkewY</td><td>Sets the property SkewY</td><td>skew angle; </td><td>-</td><td>public</td></tr>
<tr><td>setTransformation</td><td>Sets the property Transformation</td><td>trans transformation - [scaleX, skewY, skewX, scaleY, translateX, translateY]; </td><td>-</td><td>public</td></tr>
<tr><td>setVisible</td><td>Sets the property Visibility</td><td>visible boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setX(x)</td><td>Sets the property X</td><td>x double; </td><td>-</td><td>public</td></tr>
<tr><td>setY(y)</td><td>Sets the property Y</td><td>y double; </td><td>-</td><td>public</td></tr>
<tr><td>toElementSpace</td><td>Transforms a double[] point in the group's world coordinates to
 the element's world coordinates
 Note: Transformations are not considered!</td><td>point double[] The original coordinates in the body frame; </td><td>double[] The same array once translated</td><td>private</td></tr>
<tr><td>toGroupSpace</td><td>Transforms a double[] point in the element's world coordinates to
 the group's world coordinates</td><td>point double[] The original coordinates in the body frame; withTransf bool Considering group transformations; </td><td>double[] The same array once transformed</td><td>private</td></tr>
<tr><td>toGroupSpaceMod</td><td>Transforms a module (longitude or size) in the element's world coordinates to
 the group's world coordinates</td><td>mod double[] The original module in the body frame; </td><td>double[] The same array once transformed</td><td>private</td></tr>
<tr><td>unserialize</td><td>Set JSON object with private variables</td><td>-</td><td>-</td><td>private</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.Histogram'>EJSS_DRAWING2D.Histogram</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Histogram</td><td>A Histogram displays a diagram of frequencies of data</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></td></tr>
</tbody></table>
<br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>Active</td><td>Whether the histogram actually accepts input values</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>BinWidth</td><td>The width of the bins. This is the maximum distance that makes two inputs contribute 
 to the same bin height. As an example, is the with is 0.5, the inputs 1.1 and 1.4 
 will add their occurrences to the same bin</td><td>int or double</td><td>1</td><td>-</td></tr>
<tr><td>ClearAtInput</td><td>Whether to clear old data whenever new data gets in</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Discrete</td><td>Whether the bins are discrete or continuous. A discrete bin looks like a thin vertical line, 
 a continuous one looks like a bar with the width of the bin</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>FixBin</td><td>Fix bin in the input</td><td>double</td><td>0</td><td>-</td></tr>
<tr><td>Normalized</td><td>Whether the data are normalized to one</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Occurrences</td><td>The number of the occurrences of the input</td><td>int or double</td><td>1</td><td>-</td></tr>
<tr><td>PixelPosition</td><td>The input value to append</td><td>double or double[]</td><td>false</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>getBigMark</td><td>Gets the interval for big marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>getMediumMark</td><td>Gets the interval for medium marks</td><td>-</td><td>value int</td><td>public</td></tr>
<tr><td>getNumberOfMarks</td><td>Gets the number of marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>getPrecision</td><td>Gets the number of digits for the marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>setBigMark(value)</td><td>Sets the interval for big marks</td><td>value int; </td><td>-</td><td>public</td></tr>
<tr><td>setDigits(value)</td><td>Sets the number of digits for the marks</td><td>value int; </td><td>-</td><td>public</td></tr>
<tr><td>setMediumMark(value)</td><td>Sets the interval for medium marks</td><td>value int; </td><td>-</td><td>public</td></tr>
<tr><td>setNumberOfMarks(value)</td><td>Sets the number of marks</td><td>value int; </td><td>-</td><td>public</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.PlottingPanel'>EJSS_DRAWING2D.PlottingPanel</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.PlottingPanel</td><td>A PlottingPanel is a 2D drawing panel with added decoration. The decoration includes axes, gutters and titles.</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.DrawingPanel'>EJSS_DRAWING2D.DrawingPanel</a></td></tr>
</tbody></table>
<br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>Title</td><td>The title at the top center of the panel</td><td>String</td><td>"Plot"</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>getAxisX()</td><td>-</td><td>-</td><td>the axis element for the X dimension</td><td>public</td></tr>
<tr><td>getAxisY()</td><td>-</td><td>-</td><td>the axis element for the Y dimension</td><td>public</td></tr>
<tr><td>getBigMark</td><td>Gets the interval for big marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>getMarkFactor</td><td>Gets the factor that divide the displayed value in marks</td><td>-</td><td>int|double</td><td>public</td></tr>
<tr><td>getMaximumMark</td><td>Gets the maximum value to display in a mark</td><td>-</td><td>value int|double</td><td>public</td></tr>
<tr><td>getMediumMark</td><td>Gets the interval for medium marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>getNumberOfMarks</td><td>Gets the number of marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>getPrecision</td><td>Gets the number of digits for the marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>setBigMark(value)</td><td>Sets the interval for big marks</td><td>value int; </td><td>-</td><td>public</td></tr>
<tr><td>setDigits(value)</td><td>Sets the number of digits for the marks</td><td>value int; </td><td>-</td><td>public</td></tr>
<tr><td>setMarkFactor(value)</td><td>Sets the factor that divide the value in marks</td><td>value int|double; </td><td>-</td><td>public</td></tr>
<tr><td>setMaximumMark(value)</td><td>Sets the maximum value to display in a mark</td><td>value int|double; </td><td>-</td><td>public</td></tr>
<tr><td>setMediumMark(value)</td><td>Sets the interval for medium marks</td><td>value int; </td><td>-</td><td>public</td></tr>
<tr><td>setNumberOfMarks(value)</td><td>Sets the number of marks</td><td>value int; </td><td>-</td><td>public</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.Segment'>EJSS_DRAWING2D.Segment</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Segment</td><td>A Segment is a 2D drawing element that displays a single line</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></td></tr>
</tbody></table>
<br><br><br>
<h3><a name='EJSS_DRAWING2D.Shape'>EJSS_DRAWING2D.Shape</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Shape</td><td>A Shape is a 2D drawing element that displays a 2D shape (such as a rectangle, ellipse, etc.)</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></td></tr>
</tbody></table>
<br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>CornerRadius</td><td>Radius for the corners of a round rectangular shape</td><td>int</td><td>10</td><td>-</td></tr>
<tr><td>FillColor</td><td>-</td><td>-</td><td>"Blue"</td><td>-</td></tr>
<tr><td>LineColor</td><td>-</td><td>-</td><td>"Black"</td><td>-</td></tr>
<tr><td>RelativePosition</td><td>-</td><td>-</td><td>"CENTER"</td><td>-</td></tr>
<tr><td>ShapeType</td><td>Type of shape</td><td>int|String</td><td>"ELLIPSE"</td><td>0:"NONE", 1:"ELLIPSE", 2:"RECTANGLE", 3:"ROUND_RECTANGLE", 4:"WHEEL", 5:"POINT"</td></tr>
<tr><td>Size</td><td>-</td><td>-</td><td>[0.1,0.1]</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>copyTo</td><td>Extended copyTo method</td><td>Element; </td><td>-</td><td>private</td></tr>
<tr><td>getClass</td><td>Returns the class name</td><td>-</td><td>String</td><td>private</td></tr>
<tr><td>getCornerRadius</td><td>Gets the value of the property CornerRadius</td><td>-</td><td>int</td><td>-</td></tr>
<tr><td>getShapeType</td><td>Gets the value of the property ShapeType</td><td>-</td><td>int|String</td><td>public</td></tr>
<tr><td>registerProperties</td><td>Extended registerProperties method</td><td>controller; </td><td>-</td><td>private</td></tr>
<tr><td>setCornerRadius</td><td>Sets the value of the property CornerRadius</td><td>radius int; </td><td>-</td><td>-</td></tr>
<tr><td>setShapeType(shapeType)</td><td>Sets the value of the property ShapeType</td><td>shapeType int|String; </td><td>-</td><td>public</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.SimplePanel'>EJSS_DRAWING2D.SimplePanel</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.SimplePanel</td><td>A SimplePanel is a 2D drawing panel with no decoration.</td></tr>
</tbody></table>
<br><br><br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>setRadius</td><td>Set radius</td><td>radius; </td><td>-</td><td>-</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.Text'>EJSS_DRAWING2D.Text</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Text</td><td>A Text is a 2D drawing element that displays a text</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></td></tr>
</tbody></table>
<br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>FillColor</td><td>Fill color</td><td>String</td><td>"none"</td><td>-</td></tr>
<tr><td>Font</td><td>Font description in one declaration</td><td>String - https://www.w3schools.com/cssref/pr_font_font.asp</td><td>"20px Arial"</td><td>-</td></tr>
<tr><td>FontFamily</td><td>Font family</td><td>String</td><td>"Arial"</td><td>-</td></tr>
<tr><td>FontSize</td><td>Font size</td><td>String</td><td>"20"</td><td>-</td></tr>
<tr><td>FontStyle</td><td>Font style</td><td>String</td><td>"normal"</td><td>-</td></tr>
<tr><td>OutlineColor</td><td>Outline color</td><td>String</td><td>"none"</td><td>-</td></tr>
<tr><td>Text</td><td>Text</td><td>String</td><td>""</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>getText</td><td>Gets text</td><td>-</td><td>string</td><td>public</td></tr>
<tr><td>setText</td><td>Sets text</td><td>string; </td><td>-</td><td>public</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.Trace'>EJSS_DRAWING2D.Trace</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Trace</td><td>A Trace is a sophistication of the Trail element. 
 The extra features are the possibility to specify markers that will be displayed at 
 each point of the trace.</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Trail'>EJSS_DRAWING2D.Trail</a></td></tr>
</tbody></table>
<br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>MarkAxisY</td><td>Axis for bar or area markers</td><td>int</td><td>0</td><td>-</td></tr>
<tr><td>MarkDrawFill</td><td>Whether the marker are filled</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>MarkDrawLines</td><td>Whether the marker lines are drawn</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>MarkFillColor</td><td>The fill color for the markers</td><td>String</td><td>"Blue"</td><td>-</td></tr>
<tr><td>MarkLineColor</td><td>Color for the lines of the markers</td><td>String</td><td>"Black"</td><td>-</td></tr>
<tr><td>MarkLineWidth</td><td>Marker stroke width</td><td>double</td><td>0.5</td><td>-</td></tr>
<tr><td>MarkRelativePosition</td><td>Position of the marker relative to the point</td><td>int|String</td><td>"CENTER</td><td>"CENTER":0,"NORTH":1,"SOUTH":2,"EAST":3,"WEST":4,"NORTH_EAST":5,"NORTH_WEST":6, "SOUTH_EAST":7,"SOUTH_WEST":8</td></tr>
<tr><td>MarkSize</td><td>Size of the marker to draw</td><td>int[2] providing the width and height in pixels</td><td>[0,0]</td><td>-</td></tr>
<tr><td>MarkType</td><td>Type of marker to draw</td><td>int|String</td><td>"ELLIPSE"</td><td>0="ELLIPSE", 1="RECTANGLE", 2:"AREA", 3:"BAR"</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>getMarkAxisY()</td><td>Get the limit axis for bar or area marks</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>getMarkSize()</td><td>Get the sizes of the mark</td><td>-</td><td>double[]</td><td>public</td></tr>
<tr><td>getMarkStyle()</td><td>Return the style of the mark</td><td>-</td><td>-</td><td>public</td></tr>
<tr><td>getMarkStyleList()</td><td>Get the list of styles</td><td>-</td><td>list</td><td>public</td></tr>
<tr><td>getMarkType()</td><td>Get the type of the mark</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>setMarkAxisY()</td><td>Set the limit axis for bar or area marks</td><td>int; </td><td>-</td><td>public</td></tr>
<tr><td>setMarkSize(size)</td><td>Set the size of the mark</td><td>size int[2]|double[2] array with the size in pixels; </td><td>-</td><td>public</td></tr>
<tr><td>setMarkType(type)</td><td>Set the type of the mark</td><td>type int|String One of: "CENTER":0,"NORTH":1,"SOUTH":2,"EAST":3,"WEST":4,"NORTH_EAST":5,"NORTH_WEST":6,                 "SOUTH_EAST":7,"SOUTH_WEST":8; </td><td>-</td><td>public</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING2D.Trail'>EJSS_DRAWING2D.Trail</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING2D.Trail</td><td>A Trail is a two-dimensional drawable that displays a collection of points in the plane. 
 The points are added to the trail either through the <tt>InputX</tt> and <tt>InputY</tt>
 properties, or using the element’s <tt>addPoint</tt> or <tt>moveToPoint</tt> functions. 
 The points are displayed using lines which connect the points, each with the previous one, 
 thus forming a polygonal line (which looks like a trail). The trail can be disconnected 
 at some points if the <tt>Connected</tt> property is set temporarily to false, or if 
 the <tt>moveToPoint</tt> function is used.<br/> 
 The number of points in a trail can be limited through the <tt>Maximum</tt> property. 
 Adding points past the limit causes the trail to remove the first points in it.<br/>
<br/>
 Trails can be broken into several segments using the <tt>newSegment</tt> function. 
 Each segment behaves like a sub-trail, but segments can have different drawing 
 styles (line width and color). Also, the user can delete the points in the last 
 segment without affecting the previous segments.</td></tr>
</tbody></table>
<br><table><thead><th>Parent</th></thead><tbody>
<tr><td><a href='#EJSS_DRAWING2D.Element'>EJSS_DRAWING2D.Element</a></td></tr>
</tbody></table>
<br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>Active</td><td>Whether the trail should accept input points.</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>ClearAtInput</td><td>Whether the trail clears all points when receiving new input. (Useful if input is an array.)</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Connected</td><td>Whether the next input point should be connected to the previous one.</td><td>boolean</td><td>true</td><td>-</td></tr>
<tr><td>Input</td><td>The next input point for the trail.</td><td>int[2]|double[2] An array with a pair of [x,y] coordinates,  or int[n][2]|double[n][2] a double array with n pairs of [x,y] coordinates.</td><td>"none"</td><td>-</td></tr>
<tr><td>InputX</td><td>The X coordinate for the next input point for the trail.</td><td>int|double The X coordinate for the input point  or int[n]|double[n] a double array with the X coordinates for n input points.</td><td>"none"</td><td>-</td></tr>
<tr><td>InputY</td><td>The Y coordinate for the next input point for the trail.</td><td>int|double The Y coordinate for the input point  or int[n]|double[n] a double array with the Y coordinates for n input points.</td><td>"none"</td><td>-</td></tr>
<tr><td>Maximum</td><td>The maximum number of points the trail accepts. If more input is received, the trail
 will discard the corresponding first points.</td><td>int</td><td>0 indicating no limit</td><td>-</td></tr>
<tr><td>NoRepeat</td><td>Whether the trail ignores repeated input points</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>RelativePosition</td><td>-</td><td>-</td><td>"SOUTH_WEST"</td><td>-</td></tr>
<tr><td>Skip</td><td>Whether the trail should display only one oout of many inpout points. 
 If Skip is positive, it indicates how many points the trail will take to display one.</td><td>int</td><td>0</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>addPoint(x,y,style)</td><td>Adds a new point to the trail.</td><td>x double The X coordinate of the point  		or point double[] The double[2] array with the coordinates of the point.; y double The Y coordinate of the point.; style int an optional connection style: 0 = EJSS_DRAWING2D.Trail.NO_CONNECTION, 1 = EJSS_DRAWING2D.Trail.LINE_CONNECTION; </td><td>-</td><td>public</td></tr>
<tr><td>addPoints(x,y)</td><td>Adds an array of points to the trail.</td><td>x double The double[] array with the X coordinates of the points. 	or  point double[][] The double[nPoints][2] array with the coordinates of the points.; y double The double[] array with the Y coordinates of the points.; len int The number of points to copy.; </td><td>-</td><td>public</td></tr>
<tr><td>clear()</td><td>Clears all points from all segments of the trail.</td><td>-</td><td>-</td><td>public</td></tr>
<tr><td>clearLastSegment()</td><td>Clears all points from the last segment of the trail.</td><td>-</td><td>-</td><td>public</td></tr>
<tr><td>getActive()</td><td>Whether the trail is in active mode.</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getClearAtInput()</td><td>Whether the trail is in clear at input mode.</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>getConnected()</td><td>Gets the connection state.</td><td>-</td><td>boolean</td><td>public</td></tr>
<tr><td>getMaximumPoints()</td><td>Returns the maximum number of points allowed for the trail</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>getNoRepeat()</td><td>Whether the trail is in no repeat mode.</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getSkip()</td><td>Returns the skip parameter of the trail.</td><td>-</td><td>int</td><td>public</td></tr>
<tr><td>initialize()</td><td>Clears all points from the last segment of the trail, 
 respecting previous segments.</td><td>-</td><td>-</td><td>public</td></tr>
<tr><td>moveToPoint(x,y)</td><td>Moves to the new point without drawing.
 (Equivalent to setting the connection type
 to NO_CONNECTION and adding one single point, then setting the 
 type back to its previous value.)</td><td>x double The X coordinate of the point. 	or point double[] The double[2] array with the coordinates of the point.; y double The Y coordinate of the point.; </td><td>-</td><td>public</td></tr>
<tr><td>newSegment()</td><td>Creates a new segment of the trail.</td><td>-</td><td>-</td><td>public</td></tr>
<tr><td>reset()</td><td>Same as clear</td><td>-</td><td>-</td><td>public</td></tr>
<tr><td>serialize</td><td>Get JSON object with private variables</td><td>-</td><td>-</td><td>private</td></tr>
<tr><td>setActive(active)</td><td>Sets the active state of the trail. An inactive trail ignores all input.</td><td>active boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setClearAtInput(clear)</td><td>Sets the trail to clear existing points when receiving 
 a new point or array of points.</td><td>clear boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setConnected(connected)</td><td>Whether to connect next input point with the previous one</td><td>connected boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setMaximumPoints(maximum)</td><td>Sets the maximum number of points for the trail.
 Once the maximum is reached, adding a new point will cause
 remotion of the first one. This is useful to keep trails
 down to a reasonable size, since very long trails can slow
 down the rendering (in certain implementations).
 If the value is 0 (the default) the trail grows forever
 without discarding old points.</td><td>maximum int; </td><td>-</td><td>public</td></tr>
<tr><td>setNoRepeat(noRepeat)</td><td>Sets the no repeat state of the trail.
 When set, a trail will ignore (x,y) points which equal the last added point.</td><td>noRepeat boolean; </td><td>-</td><td>public</td></tr>
<tr><td>setSkip(skip)</td><td>Sets the skip parameter. When the skip parameter is larger than zero,
 the trail only considers one of every 'skip' points. That is, if skip is 3, 
 the trail will consider only every third point sent to it. 
 The default is zero, meaning all points must be considered.</td><td>skip int; </td><td>-</td><td>public</td></tr>
<tr><td>unserialize</td><td>Set JSON object with private variables</td><td>-</td><td>-</td><td>private</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING3D.Arrow'>EJSS_DRAWING3D.Arrow</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.Arrow</td><td>Arrow is a class to display vectors in 3D</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>HeadHeight</td><td>Ratio arrow_length/head_length</td><td>double</td><td>"8"</td><td>-</td></tr>
<tr><td>HeadWidth</td><td>Ratio arrow_length/head_width</td><td>double</td><td>"20"</td><td>-</td></tr>
</tbody></table>
<br><br>
<h3><a name='EJSS_DRAWING3D.ArrowSet'>EJSS_DRAWING3D.ArrowSet</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.ArrowSet</td><td>ArrowSet is a set of Arrows</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>HeadHeight</td><td>Ratio arrow_length/head_length</td><td>double</td><td>"8"</td><td>-</td></tr>
<tr><td>HeadWidth</td><td>Ratio arrow_length/head_width</td><td>double</td><td>"20"</td><td>-</td></tr>
</tbody></table>
<br><br>
<h3><a name='EJSS_DRAWING3D.Cylinder'>EJSS_DRAWING3D.Cylinder</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.Cylinder</td><td>Cylinder</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>BottomRadius</td><td>Bottom radius</td><td>number</td><td>1</td><td>-</td></tr>
<tr><td>MaxAngleU</td><td>Maximum angle in drawing</td><td>number</td><td>360</td><td>-</td></tr>
<tr><td>MinAngleU</td><td>Minimum angle in drawing</td><td>number</td><td>0</td><td>-</td></tr>
<tr><td>TopRadius</td><td>Top radius</td><td>number</td><td>1</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>setOriginAndEnd</td><td>Changes the position and Size Z and adds an extra transformation
 so that the axis of the element has the prescribed origin and end points</td><td>origin a double[3] array with the origin of the axis; end a double[3] array with the end point of the axis; </td><td>-</td><td>-</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING3D.Disk'>EJSS_DRAWING3D.Disk</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.Disk</td><td>Disk</td></tr>
</tbody></table>
<br><br><br><br>
<h3><a name='EJSS_DRAWING3D.DrawingPanel'>EJSS_DRAWING3D.DrawingPanel</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.DrawingPanel</td><td>A DrawingPanel is a 3D drawing panel.</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>CameraAltitude</td><td>Camera rotation in Y axis.</td><td>int or double (degrees)</td><td>0</td><td>-</td></tr>
<tr><td>CameraAzimuth</td><td>Camera rotation in Z axis.</td><td>int or double (degrees)</td><td>0</td><td>-</td></tr>
<tr><td>CameraFar</td><td>Far plane in 3D projection.</td><td>int</td><td>10000</td><td>-</td></tr>
<tr><td>CameraFocusX</td><td>Camera focus in X axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraFocusY</td><td>Camera focus in Y axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraFocusZ</td><td>Camera focus in Z axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraNear</td><td>Near plane in 3D projection.</td><td>int</td><td>1</td><td>-</td></tr>
<tr><td>CameraTilt</td><td>Camera rotation in X axis.</td><td>int or double (degrees)</td><td>0</td><td>-</td></tr>
<tr><td>CameraUpVectorX</td><td>Camera up vector in X axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraUpVectorY</td><td>Camera up vector in Y axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraUpVectorZ</td><td>Camera up vector in Z axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraX</td><td>Camera position in X axis.</td><td>int or double</td><td>4</td><td>-</td></tr>
<tr><td>CameraY</td><td>Camera position in Y axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraZ</td><td>Camera position in Z axis.</td><td>int or double</td><td>0</td><td>-</td></tr>
<tr><td>CameraZoomRate</td><td>Camera zoom rate.</td><td>int or double</td><td>1.10</td><td>-</td></tr>
<tr><td>Lights</td><td>Lights in scene.</td><td>array of array</td><td>[[1,2,3]]</td><td>-</td></tr>
<tr><td>MaximumX</td><td>The maximum value for the X coordinates of elements.</td><td>int or double</td><td>"+1"</td><td>-</td></tr>
<tr><td>MaximumY</td><td>The maximum value for the Y coordinates of elements.</td><td>int or double</td><td>"+1"</td><td>-</td></tr>
<tr><td>MaximumZ</td><td>The maximum value for the Z coordinates of elements.</td><td>int or double</td><td>"+1"</td><td>-</td></tr>
<tr><td>MinimumX</td><td>The minimum value for the X coordinates of elements.</td><td>int or double</td><td>"-1"</td><td>-</td></tr>
<tr><td>MinimumY</td><td>The minimum value for the Y coordinates of elements.</td><td>int or double</td><td>"-1"</td><td>-</td></tr>
<tr><td>MinimumZ</td><td>The minimum value for the Z coordinates of elements.</td><td>int or double</td><td>"-1"</td><td>-</td></tr>
<tr><td>Perspective</td><td>Field of view when perspective on. A parameter that gives more or less perspective to the projection.</td><td>int (degrees)</td><td>"45"</td><td>-</td></tr>
<tr><td>Projection</td><td>Type of projection.</td><td>int or string</td><td>"PERSPECTIVE_ON"</td><td>"PLANAR_XY": 0; "PLANAR_XZ": 1; "PLANAR_YZ": 2; "PERSPECTIVE_OFF": 3; "PERSPECTIVE_ON": 4;</td></tr>
<tr><td>SizeX</td><td>Size for the X axis.</td><td>int or double</td><td>1</td><td>-</td></tr>
<tr><td>SizeY</td><td>Size for the Y axis.</td><td>int or double</td><td>1</td><td>-</td></tr>
<tr><td>SizeZ</td><td>Size for the Z axis.</td><td>int or double</td><td>1</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>addDecoration</td><td>Adds a decoration to the panel. Decorations are drawn before any other elements.</td><td>drawable decoration element; position integer; </td><td>-</td><td>-</td></tr>
<tr><td>addElement</td><td>Add a element to the panel. Elements are asked to draw themselves
 whenever the panel needs to render. For this purpose, they will receive a
 calls to draw().
 Elements are reported of changes in the world coordinates of the panel, in case
 they need to recalculate themselves.</td><td>element Element; position int; </td><td>-</td><td>-</td></tr>
<tr><td>getAutoCamera</td><td>Gets auto camera</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getCamAltitude</td><td>Gets altitude for camera</td><td>-</td><td>altitude</td><td>-</td></tr>
<tr><td>getCamAzimuth</td><td>Gets azimuth for camera</td><td>-</td><td>azimuth</td><td>-</td></tr>
<tr><td>getCamFocus</td><td>Gets focus for camera</td><td>-</td><td>vector</td><td>-</td></tr>
<tr><td>getCamFocusX</td><td>Gets X focus for camera</td><td>-</td><td>x</td><td>-</td></tr>
<tr><td>getCamFocusY</td><td>Gets Y focus for camera</td><td>-</td><td>y</td><td>-</td></tr>
<tr><td>getCamFocusZ</td><td>Gets Z focus for camera</td><td>-</td><td>z</td><td>-</td></tr>
<tr><td>getCamLoc</td><td>Gets coordinates for camera</td><td>-</td><td>vector</td><td>-</td></tr>
<tr><td>getCamLocX</td><td>Gets X coordinate for camera</td><td>-</td><td>x</td><td>-</td></tr>
<tr><td>getCamLocY</td><td>Gets Y coordinate for camera</td><td>-</td><td>y</td><td>-</td></tr>
<tr><td>getCamLocZ</td><td>Gets Z coordinate for camera</td><td>-</td><td>z</td><td>-</td></tr>
<tr><td>getCamTilt</td><td>Gets tilt for camera</td><td>-</td><td>tilt</td><td>-</td></tr>
<tr><td>getCamUpVector</td><td>Gets Up Vector for camera</td><td>-</td><td>vector [x,y,z]</td><td>-</td></tr>
<tr><td>getCamUpVectorX</td><td>Gets X Up Vector for camera</td><td>-</td><td>x</td><td>-</td></tr>
<tr><td>getCamUpVectorY</td><td>Gets Y Up Vector for camera</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>getCamUpVectorZ</td><td>Gets Z Up Vector for camera</td><td>-</td><td>z</td><td>-</td></tr>
<tr><td>getController</td><td>Returns the controller object</td><td>-</td><td>Controller</td><td>-</td></tr>
<tr><td>getElements</td><td>Return the array of a elements.</td><td>-</td><td>Elements</td><td>-</td></tr>
<tr><td>getFOV</td><td>Get field of view in non-orthographic projection</td><td>int; </td><td>-</td><td>-</td></tr>
<tr><td>getFar</td><td>Get far plane in non-orthographic projection</td><td>number; </td><td>-</td><td>-</td></tr>
<tr><td>getGraphics</td><td>Returns the graphics implementation</td><td>-</td><td>Graphics</td><td>-</td></tr>
<tr><td>getLights</td><td>Gets lights</td><td>-</td><td>array of array</td><td>-</td></tr>
<tr><td>getName</td><td>Get name for drawing panel</td><td>-</td><td>string</td><td>-</td></tr>
<tr><td>getNear</td><td>Get near plane in non-orthographic projection</td><td>number; </td><td>-</td><td>-</td></tr>
<tr><td>getOrthographic</td><td>Whether the projection is orthographic</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getPanelInteraction</td><td>Return panel interaction</td><td>-</td><td>panel interaction</td><td>-</td></tr>
<tr><td>getProjection</td><td>Get the type of projection</td><td>-</td><td>type</td><td>-</td></tr>
<tr><td>getSize</td><td>Get the sizes of the elements</td><td>-</td><td>double[]</td><td>-</td></tr>
<tr><td>getSizeX</td><td>Get the size along the X coordinate of the elements</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getSizeY</td><td>Get the size along the Y coordinate of the elements</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getSizeZ</td><td>Get the size along the Z coordinate of the elements</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getStyle</td><td>Return the drawing style of the inner rectangle for panel</td><td>-</td><td>Style</td><td>-</td></tr>
<tr><td>getWorldCoordinates</td><td>Gets the preferred user coordinates for the panel</td><td>-</td><td>bounds</td><td>-</td></tr>
<tr><td>getWorldXMax</td><td>Returns the preferred maximum X coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldXMin</td><td>Returns the preferred minimum X coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldYMax</td><td>Returns the preferred maximum Y coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldYMin</td><td>Returns the preferred minimum Y coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldZMax</td><td>Returns the preferred maximum Z coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getWorldZMin</td><td>Returns the preferred minimum Z coordinate for the panel</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getZoomRate</td><td>Gets zoom rate</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>indexOfElement</td><td>Return the position of a element.</td><td>element Element; </td><td>integer</td><td>-</td></tr>
<tr><td>removeDecoration</td><td>Removes a decoration</td><td>drawable decoration element; </td><td>-</td><td>-</td></tr>
<tr><td>removeElement</td><td>Remove a element to the panel.</td><td>element Element; </td><td>-</td><td>-</td></tr>
<tr><td>render</td><td>Render the scene</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>reset</td><td>Reset the scene</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>setCamAltitude</td><td>Sets altitude for camera</td><td>altitude (degrees); </td><td>-</td><td>-</td></tr>
<tr><td>setCamAzimuth</td><td>Sets azimuth for camera</td><td>azimuth (degrees); </td><td>-</td><td>-</td></tr>
<tr><td>setCamFocus</td><td>Sets focus for camera</td><td>vector [x,y,z]; </td><td>-</td><td>-</td></tr>
<tr><td>setCamFocusX</td><td>Sets X focus for camera</td><td>x; </td><td>-</td><td>-</td></tr>
<tr><td>setCamFocusY</td><td>Sets Y focus for camera</td><td>y; </td><td>-</td><td>-</td></tr>
<tr><td>setCamFocusZ</td><td>Sets Z focus for camera</td><td>z; </td><td>-</td><td>-</td></tr>
<tr><td>setCamLoc</td><td>Sets coordinates for camera</td><td>vector [x,y,z]; </td><td>-</td><td>-</td></tr>
<tr><td>setCamLocX</td><td>Sets X coordinate for camera</td><td>x; </td><td>-</td><td>-</td></tr>
<tr><td>setCamLocY</td><td>Sets Y coordinate for camera</td><td>y; </td><td>-</td><td>-</td></tr>
<tr><td>setCamLocZ</td><td>Sets Z coordinate for camera</td><td>z; </td><td>-</td><td>-</td></tr>
<tr><td>setCamTilt</td><td>Sets tilt for camera</td><td>tilt (degrees); </td><td>-</td><td>-</td></tr>
<tr><td>setCamUpVector</td><td>Sets Up Vector for camera</td><td>vector [x,y,z]; </td><td>-</td><td>-</td></tr>
<tr><td>setCamUpVectorX</td><td>Sets X Up Vector for camera</td><td>x; </td><td>-</td><td>-</td></tr>
<tr><td>setCamUpVectorY</td><td>Sets Y Up Vector for camera</td><td>y; </td><td>-</td><td>-</td></tr>
<tr><td>setCamUpVectorZ</td><td>Sets Z Up Vector for camera</td><td>z; </td><td>-</td><td>-</td></tr>
<tr><td>setController</td><td>Set the controller</td><td>Controller; </td><td>-</td><td>-</td></tr>
<tr><td>setDecorationType</td><td>Set visible a specific type of decoration</td><td>type "NONE", "AXES", "CUBE", "CENTERED_AXIS"; </td><td>-</td><td>-</td></tr>
<tr><td>setDraggable</td><td>How the panel should respond to user interaction</td><td>draggable "NONE", "ANY", "AZIMUTH", "ALTITUDE"; </td><td>-</td><td>-</td></tr>
<tr><td>setEnabled</td><td>Whether the panel should respond to user interaction</td><td>enabled boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setFOV</td><td>Set field of view in non-orthographic projection</td><td>-</td><td>int</td><td>-</td></tr>
<tr><td>setFar</td><td>Set far plane in non-orthographic projection</td><td>-</td><td>number</td><td>-</td></tr>
<tr><td>setGraphics</td><td>Set graphics (only Webgl supported)</td><td>type; </td><td>-</td><td>-</td></tr>
<tr><td>setLights</td><td>Set lights</td><td>array of array; </td><td>-</td><td>-</td></tr>
<tr><td>setNear</td><td>Set near plane in non-orthographic projection</td><td>-</td><td>number</td><td>-</td></tr>
<tr><td>setOrthographic</td><td>Set orthographic projection</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setProjection</td><td>Set the type of projection</td><td>-</td><td>type "PLANAR_XY", "PLANAR_XZ", "PLANAR_YZ", "PERSPECTIVE_OFF", "PERSPECTIVE_ON"</td><td>-</td></tr>
<tr><td>setSize</td><td>Set the size of the elements</td><td>position double[] an array of dimension 3 or an object with {x,y,z} properties; </td><td>-</td><td>-</td></tr>
<tr><td>setSizeX</td><td>Set the size along the X axis of the elements</td><td>sizeX double; </td><td>-</td><td>-</td></tr>
<tr><td>setSizeY</td><td>Set the size along the Y axis of the elements</td><td>sizeY double; </td><td>-</td><td>-</td></tr>
<tr><td>setSizeZ</td><td>Set the size along the Z axis of the elements</td><td>sizeZ double; </td><td>-</td><td>-</td></tr>
<tr><td>setVisibleDecorationAxis</td><td>Set visible decoration shown traditional axis</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setVisibleDecorationBasicAxis</td><td>Set visible decoration shown basic axis</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setVisibleDecorationBox</td><td>Set visible decoration shown box</td><td>boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldCoordinates</td><td>Sets the preferred user coordinates for the panel</td><td>bounds; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldXMax</td><td>Sets the preferred maximum X coordinate for the panel</td><td>xmax; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldXMin</td><td>Sets the preferred minimum X coordinate for the panel</td><td>xmin; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldYMax</td><td>Sets the preferred maximum Y coordinate for the panel</td><td>ymax; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldYMin</td><td>Sets the preferred minimum Y coordinate for the panel</td><td>ymin; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldZMax</td><td>Sets the preferred maximum Z coordinate for the panel</td><td>zmax; </td><td>-</td><td>-</td></tr>
<tr><td>setWorldZMin</td><td>Sets the preferred minimum Y coordinate for the panel</td><td>zmin; </td><td>-</td><td>-</td></tr>
<tr><td>setZoomRate</td><td>Sets zoom rate</td><td>double; </td><td>-</td><td>-</td></tr>
<tr><td>supportsWebGL</td><td>Whether webgl is supported</td><td>-</td><td>boolean</td><td>-</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING3D.Element'>EJSS_DRAWING3D.Element</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.Element</td><td>Element is the basic class for 3D elements</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>EnabledPosition</td><td>Whether the user could change the position</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>EnabledSize</td><td>Whether the user could change the size</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>MovesGroup</td><td>Whether the group position also changes when the element position changes</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Parent</td><td>Parent of the element</td><td>Panel|Group</td><td>-</td><td>-</td></tr>
<tr><td>Position</td><td>Coordinates X, Y, and Z</td><td>double[3]</td><td>[0,0,0]</td><td>-</td></tr>
<tr><td>ResizesGroup</td><td>Whether the group size also changes when the element size changes</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>Size</td><td>Size along the X, Y, and Z axes</td><td>double[3]</td><td>[1,1,1]</td><td>-</td></tr>
<tr><td>SizeX</td><td>Size along the X axis</td><td>double</td><td>1</td><td>-</td></tr>
<tr><td>SizeY</td><td>Size along the Y axis</td><td>double</td><td>1</td><td>-</td></tr>
<tr><td>SizeZ</td><td>Size along the Z axis</td><td>double</td><td>1</td><td>-</td></tr>
<tr><td>X</td><td>Position in X</td><td>double</td><td>0</td><td>-</td></tr>
<tr><td>Y</td><td>Position in Y</td><td>double</td><td>0</td><td>-</td></tr>
<tr><td>Z</td><td>Position in Z</td><td>double</td><td>0</td><td>-</td></tr>
</tbody></table>
<br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>copyTo</td><td>Copies itself to another element</td><td>element Element; </td><td>-</td><td>-</td></tr>
<tr><td>getController</td><td>Returns the controller object</td><td>-</td><td>Controller</td><td>-</td></tr>
<tr><td>getGroup</td><td>Get the group of this element, if any</td><td>-</td><td>Group</td><td>-</td></tr>
<tr><td>getGroupPanel</td><td>Returns the DrawingPanel in which it (or its final ancestor group) is displayed.</td><td>-</td><td>drawing3D.DrawingPanel</td><td>-</td></tr>
<tr><td>getGroupTransformation</td><td>Get the group transformation of the element.</td><td>-</td><td>Transformation</td><td>-</td></tr>
<tr><td>getName</td><td>Get name for element</td><td>-</td><td>string</td><td>-</td></tr>
<tr><td>getPanel</td><td>For internal use only, use getGroupPanel() instead. Gets the panel for this element.</td><td>-</td><td>DrawingPanel</td><td>-</td></tr>
<tr><td>getParent</td><td>Get the parent</td><td>-</td><td>parent Panel or Element</td><td>-</td></tr>
<tr><td>getPosition</td><td>Get the coordinates of the element</td><td>-</td><td>double[3]</td><td>-</td></tr>
<tr><td>getSetIndex</td><td>Get the index of this element in a set, if any</td><td>-</td><td>int</td><td>-</td></tr>
<tr><td>getSize</td><td>Get the sizes of the element</td><td>-</td><td>double[]</td><td>-</td></tr>
<tr><td>getSizeX</td><td>Get the size along the X coordinate of the element</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getSizeY</td><td>Get the size along the Y coordinate of the element</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getSizeZ</td><td>Get the size along the Z coordinate of the element</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getStyle</td><td>Return the style (defined in DrawingPanel.js) of the inner rectangle</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>getTextureUrl</td><td>Get texture url</td><td>-</td><td>url</td><td>-</td></tr>
<tr><td>getTransformation</td><td>Get the internal transformation of the element.</td><td>-</td><td>Transformation</td><td>-</td></tr>
<tr><td>getX</td><td>Get the X coordinate of the element</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getY</td><td>Get the Y coordinate of the element</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>getZ</td><td>Get the Z coordinate of the element</td><td>-</td><td>double</td><td>-</td></tr>
<tr><td>isAlwaysUpdated</td><td>Whether element mesh must be always drawn</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>isChanged</td><td>Whether the element projection has changed</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>isGroupChanged</td><td>Returns whether the element group has changed.</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>isGroupVisible</td><td>Returns the real visibility status of the element, which will be false if
 it belongs to an invisible group</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>isMeasured</td><td>Whether the element is measured</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>isVisible</td><td>Whether the element is visible</td><td>-</td><td>boolean</td><td>-</td></tr>
<tr><td>registerProperties</td><td>Registers properties in a ControlElement</td><td>controller A ControlElement that becomes the element controller; </td><td>-</td><td>-</td></tr>
<tr><td>setAlwaysUpdated</td><td>Tells whether element mesh must be always drawn</td><td>always boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setColor</td><td>Set color</td><td>color; </td><td>-</td><td>-</td></tr>
<tr><td>setController</td><td>Set the controller</td><td>Controller; </td><td>-</td><td>-</td></tr>
<tr><td>setGroup</td><td>To be used internally by Group only! Sets the group of this element.</td><td>group Group; </td><td>-</td><td>-</td></tr>
<tr><td>setMeasured</td><td>Sets the measurability of the element</td><td>measured boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setMeshChanged</td><td>Tells the element mesh that it has changed.
 Typically used by subclasses when they change something.</td><td>changed boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setPanel</td><td>To be used internally by DrawingPanel only! Sets the panel for this element.</td><td>panel DrawingPanel; </td><td>-</td><td>-</td></tr>
<tr><td>setParent</td><td>Set the parent</td><td>parent Panel or Element; </td><td>-</td><td>-</td></tr>
<tr><td>setPosition</td><td>Set the coordinates of the element</td><td>position double[] an array of dimension 3; </td><td>-</td><td>-</td></tr>
<tr><td>setProjChanged</td><td>Tells the element projection that it has changed.
 Typically used by subclasses when they change something.</td><td>changed boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setSet</td><td>To be used internally by ElementSet only! Sets the index of this element in the set</td><td>set ElementSet; index int; </td><td>-</td><td>-</td></tr>
<tr><td>setSize</td><td>Set the size of the element</td><td>position double[] an array of dimension 3 or an object with {x,y,z} properties; </td><td>-</td><td>-</td></tr>
<tr><td>setSizeX</td><td>Set the size along the X axis of the element</td><td>sizeX double; </td><td>-</td><td>-</td></tr>
<tr><td>setSizeY</td><td>Set the size along the Y axis of the element</td><td>sizeY double; </td><td>-</td><td>-</td></tr>
<tr><td>setSizeZ</td><td>Set the size along the Z axis of the element</td><td>sizeZ double; </td><td>-</td><td>-</td></tr>
<tr><td>setTextureUrl</td><td>Set texture url</td><td>url; </td><td>-</td><td>-</td></tr>
<tr><td>setTransformation</td><td>Sets the internal transformation of the element.</td><td>tr list of transformation arrays supports: rotation based on vector [angle, x, y, z, cx, cy, cz],   rotation based on element center [angle, x, y, z], custom axes [x1, x2, x3, y1, y2, y3, z1, z2, z3] or
  full transformation with a matrix 4x4; </td><td>-</td><td>-</td></tr>
<tr><td>setVisible</td><td>Sets the visibility of the element</td><td>visible boolean; </td><td>-</td><td>-</td></tr>
<tr><td>setX</td><td>Set the X coordinate of the element</td><td>x double; </td><td>-</td><td>-</td></tr>
<tr><td>setY</td><td>Set the Y coordinate of the element</td><td>y double; </td><td>-</td><td>-</td></tr>
<tr><td>setZ</td><td>Set the Z coordinate of the element</td><td>z double; </td><td>-</td><td>-</td></tr>
</tbody></table>

<h3><a name='EJSS_DRAWING3D.ElementSet'>EJSS_DRAWING3D.ElementSet</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.ElementSet</td><td>ElementSet is the basic class for a set of Elements</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>EnabledPosition</td><td>Whether the user could change the position</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>EnabledSize</td><td>Whether the user could change the size</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>MovesGroup</td><td>Whether the group position also changes when the element position changes</td><td>boolean</td><td>false</td><td>-</td></tr>
<tr><td>ResizesGroup</td><td>Whether the group size also changes when the element size changes</td><td>boolean</td><td>false</td><td>-</td></tr>
</tbody></table>
<br><br>
<h3><a name='EJSS_DRAWING3D.Sphere'>EJSS_DRAWING3D.Sphere</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>EJSS_DRAWING3D.Sphere</td><td>Sphere</td></tr>
</tbody></table>
<br><br><table><thead><th>Property</th><th>Description</th><th>Type</th><th>Default</th><th>Values</th></thead><tbody>
<tr><td>Radius</td><td>Radius</td><td>number</td><td>0.5</td><td>-</td></tr>
</tbody></table>
<br><br>
<h3><a name='TextArea'>TextArea</a></h3>
<table><thead><th>Class</th><th>Description</th></thead><tbody>
<tr><td>TextArea</td><td>TextArea</td></tr>
</tbody></table>
<br><br><br><br><table><thead><th>Method</th><th>Description</th><th>Params</th><th>Return</th><th>Visibility</th></thead><tbody>
<tr><td>_addFontResizeListener</td><td>Add a function to be called when the font size changes</td><td>listener a function to be called with possible the following parameters listener(iBase,iSize,iDelta);
 where:
  iBase the base font size in pixels 
  iSize the current font size in pixels 
  iDelta the change in pixels from the last size; </td><td>-</td><td>-</td></tr>
<tr><td>_addOnBlurAction</td><td>Add a function to be called when the window in which the model runs looses focus</td><td>listener the function to be called; </td><td>-</td><td>-</td></tr>
<tr><td>_addOnFocusAction</td><td>Add a function to be called when the window in which the model runs regains focus</td><td>listener the function to be called; </td><td>-</td><td>-</td></tr>
<tr><td>_addOrientationChangeListener</td><td>Add a function to be called when the view orientation changes</td><td>listener a function to be called with possible the following parameters listener(width,height);
 where:
  width the new inner width 
  height the new inner height; </td><td>-</td><td>-</td></tr>
<tr><td>_addResizeListener</td><td>Add a function to be called when the view size changes</td><td>listener a function to be called with possible the following parameters listener(data);
 where:
  data.width is the new inner width 
  data.height is the new inner height; </td><td>-</td><td>-</td></tr>
<tr><td>_onBlur</td><td>Run OnBlur Actions</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>_onFocus</td><td>Run OnFocus Actions</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>_setInnerHTML</td><td>Run OnFocus Actions</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>addText</td><td>Add the text and scroll to the bottom</td><td>value double; </td><td>-</td><td>-</td></tr>
<tr><td>clear</td><td>Clear the text area</td><td>-</td><td>-</td><td>-</td></tr>
<tr><td>setChangeColorOnEdit</td><td>Whether to change color onkeydown/onblur</td><td>change boolean; </td><td>-</td><td>-</td></tr>
</tbody></table>

</body></html>
